/* Generated by JTB 1.5.1 */
package examples.java.ex3jtb.visitor.signature;

import java.util.Set;

import javax.annotation.processing.AbstractProcessor;
import javax.annotation.processing.RoundEnvironment;
import javax.annotation.processing.SupportedAnnotationTypes;
import javax.annotation.processing.SupportedSourceVersion;
import javax.lang.model.SourceVersion;
import javax.lang.model.element.Element;
import javax.lang.model.element.TypeElement;
import javax.tools.Diagnostic;

import examples.java.ex3jtb.syntaxtree.NodeConstants;

/** 
 * The {@link ControlSignatureProcessor} annotation processor issues a compile error when the user
 * visitors' visit methods annotated {@link NodeFieldsSignature} are not coded against the last
 * nodes definitions.
 * <p>
 * Note: the fully qualified name of this class is a line in file
 * META-INF/services/javax.annotation.processing.Processor.
 * </p>
 *
 * @author Marc Mazas
 *  @version 1.5.0 : 02/2017 : MMa : created
 */
@SupportedAnnotationTypes("examples.java.ex3jtb.visitor.signature.NodeFieldsSignature")
// Adapt the release to your compiler level
@SupportedSourceVersion(SourceVersion.RELEASE_8)
public class ControlSignatureProcessor extends AbstractProcessor {

  /** Standard constructor */
  public ControlSignatureProcessor() {
    super();
  }

    /** {@inheritDoc} */
    @Override
    public boolean process(@SuppressWarnings("unused") final Set<? extends TypeElement> annotations,
                           final RoundEnvironment roundEnv) {
      for (final Element elem : roundEnv.getElementsAnnotatedWith(NodeFieldsSignature.class)) {
        final NodeFieldsSignature nfs = elem.getAnnotation(NodeFieldsSignature.class);
        final int osig = nfs.value()[0];
        final int nsig = nfs.value()[1];
        final int nix = nfs.value()[2];
        if (osig != nsig) {
          final String message = "Different node fields signatures (old=" + nfs.value()[0] + ", new=" +
                                 nfs.value()[1] + ") in examples.java.ex3jtb.visitor." +
                                 elem.getEnclosingElement().getSimpleName() + "#" +
                                 elem.getSimpleName() + "(final " +
                                 NodeConstants.JTB_USER_NODE_NAME[nix] + " n)";
          processingEnv.getMessager().printMessage(Diagnostic.Kind.ERROR, message);
        }
      }
      return true; // no further processing of this annotation type
    }

  }
